(* ATTENTION : la mthode applic utilise le numro de l'onglet.
   Si on insre un nouvel onglet au dbut ou au milieu, il faut
   alors ajuster les numros de pages utiliss par applic. *)


open Types



class imo_options () =

  let window = GWindow.window ~wm_name:"Options"
			      ~title:"Imoview - Options"
			      ~position:`CENTER
			      ~kind:`DIALOG
			      ~modal:true
			      ~allow_shrink:true
			      ~allow_grow:true
			      ~auto_shrink:false
			      ()
  in

  let vbox = GPack.vbox ~spacing:10
			~homogeneous:false
			~packing:window#add
			()
  in

  let onglet = GPack.notebook ~tab_pos:`TOP
			      ~tab_border:5
			      ~border_width:2
			      ~show_border:true
			      ~scrollable:true
			      ~popup:false
			      ~packing:(vbox#pack ~padding:0
						  ~fill:true
						  ~expand:true
				       )
			      ()
  in

  let _ = GtkBase.Widget.set_can_focus onglet#as_widget true
  in

  let cmd = GMisc.label ~text:"Commandes"
			~xalign:0.5
			~yalign:0.5
			~xpad:0
			~ypad:0
			~line_wrap:false
			()
  in

  let cmdField = GPack.hbox ~spacing:10
			    ~border_width:10
			    ~homogeneous:false
			    ()
  in

  let _ = GMisc.label ~text:"Intervale de temps entre 2 commandes :"
		      ~xalign:0.5
		      ~yalign:0.5
		      ~xpad:0
		      ~ypad:0
		      ~line_wrap:false
		      ~packing:(cmdField#pack ~padding:0
					      ~fill:true
					      ~expand:true
			       )
		      ()
  in

  let spinCmd = GEdit.spin_button ~adjustment:(GData.adjustment ~value:(float_of_int !Parametres.cmdTimout)
								~lower:0.
								~upper:999999.
								~step_incr:1.
								~page_incr:1000.
								~page_size:1000.
								()
					      )
				  ~packing:(cmdField#pack ~padding:0
							  ~fill:true
							  ~expand:true
					   )
				  ~rate:1.
				  ~digits:0
				  ~update_policy:`IF_VALID
				  ~numeric:true
				  ~wrap:false
				  ~snap_to_ticks:false
				  ~width:(9*(Gdk.Font.char_width cmdField#misc#style#font '9'))
				  ()
  in

  let _ = GMisc.label ~text:"ms"
		      ~xalign:0.5
		      ~yalign:0.5
		      ~xpad:0
		      ~ypad:0
		      ~line_wrap:false
		      ~packing:(cmdField#pack ~padding:0
					      ~fill:true
					      ~expand:true
			       )
		      ()
  in




  let video = GMisc.label ~text:"Vido"
			  ~xalign:0.5
			  ~yalign:0.5
			  ~xpad:0
			  ~ypad:0
			  ~line_wrap:false
			  ()
  in

  let vidField = GPack.vbox ~spacing:10
			    ~border_width:10
			    ~homogeneous:false
			    ()
  in

  let _ = GMisc.label ~text:"Ligne de commande pour encoder la vido :"
		      ~justify:`LEFT
		      ~xalign:0.
		      ~yalign:0.5
		      ~xpad:0
		      ~ypad:0
		      ~line_wrap:false
		      ~packing:(vidField#pack ~padding:0
					      ~fill:true
					      ~expand:true
			       )
		      ()
  in

  let encode = GEdit.entry ~packing:(vidField#pack ~padding:0
						   ~fill:true
						   ~expand:true
				    )
			 ~text:!Parametres.encodeLine
			 ~max_length:0
			 ~visibility:true
			 ~editable:true
			 ()
  in

  let _ = GMisc.label ~text:"%nom reprsente le nom du fichier de sortie.\n
%w et %h sont respectivement la largeur et la hauteur de la vido.\n
%fps correspond au nombre d'images par secondes.\n
%list est reprsente le fichier comportant la liste des images  encoder.\n"
		      ~justify:`FILL
		      ~xalign:0.
		      ~yalign:0.5
		      ~xpad:0
		      ~ypad:0
		      ~line_wrap:false
		      ~packing:(vidField#pack ~padding:0
					      ~fill:true
					      ~expand:true
			       )
		      ()
  in




  let _ = GMisc.separator `HORIZONTAL
			  ~packing:(vbox#pack ~padding:0
					      ~fill:false
					      ~expand:false
				   )
			  ()
  in

  let bottom = GPack.button_box `HORIZONTAL
				~spacing:10
				~child_width:80
				~child_height:24
				~layout:`SPREAD
				~packing:(vbox#pack ~padding:10
						    ~fill:false
						    ~expand:false
					 )
				()
  in

  let ok = GButton.button ~packing:(bottom#pack)
			  ~label:"Valider"
			  ()
  in

  let _ = GtkBase.Widget.set_can_focus   ok#as_widget true
  and _ = GtkBase.Widget.set_can_default ok#as_widget true
  and _ = ok#grab_default ()
  in


  let apply = GButton.button ~packing:(bottom#pack)
			     ~label:"Appliquer"
			     ()
  in

  let _ = GtkBase.Widget.set_can_focus   apply#as_widget true
  and _ = GtkBase.Widget.set_can_default apply#as_widget true
  in

  let cancel = GButton.button ~packing:(bottom#pack)
			      ~label:"Annuler"
			      ()
  in

  let _ = GtkBase.Widget.set_can_focus   cancel#as_widget true
  and _ = GtkBase.Widget.set_can_default cancel#as_widget true
  in

object(self)

  method window = window
  method vbox = vbox
  method onglet = onglet
  method ok     = ok
  method apply  = apply
  method cancel = cancel

  method onQuitter () =  window#destroy ()

  method applic page = match page
		       with
			 | 0 -> (* Command *)
				Parametres.cmdTimout  := spinCmd#value_as_int
			 | 1 -> (* Video *)
				Parametres.encodeLine := encode#text
			 | _ -> ()

initializer

  let _ = window#event#connect#key_press ~callback:(fun (event: GdkEvent.Key.t) -> begin
										     let key = GdkEvent.Key.keyval event
										     in
										       match key
										       with
											 | t when t=GdkKeysyms._Escape -> self#onQuitter ();
															  true;
											 |_ -> false
										   end
						   )

  and _ = window#connect#remove  ~callback:(fun (widget:GObj.widget) -> self#onQuitter ())
  and _ = apply #connect#clicked ~callback:(fun () -> self#applic onglet#current_page)
  and _ = ok    #connect#clicked ~callback:(fun () -> self#applic 0;
						      self#applic 1;
						      self#onQuitter ()
					   )
  and _ = cancel#connect#clicked ~callback:self#onQuitter



  and _ = onglet#prepend_page ~tab_label:video#coerce vidField#coerce
  and _ = onglet#prepend_page ~tab_label:cmd#coerce   cmdField#coerce

  and _ = onglet#goto_page 0
  in
    ()

end
