class gif_opt checked f () =

  let window = GWindow.window ~wm_name:"Option de sauvegarde GIF"
			      ~title:"Option de sauvegarde GIF"
			      ~position:`CENTER
			      ~kind:`DIALOG
			      ~modal:true
			      ~allow_shrink:false
			      ~allow_grow:false
			      ~auto_shrink:false
			   ()
  in

  let vbox = GPack.vbox ~spacing:0
			~homogeneous:false
			~packing:window#add
			()
  in

  let entrelasse = GButton.check_button ~draw_indicator:true
					~border_width:10
					~active:checked
					~label:"Utiliser l'entrelassage (GIF progressif)"
					~packing:(vbox#pack ~padding:0
							    ~fill:false
							    ~expand:false
						 )
					()
  in

  let _ = GtkBase.Widget.set_can_focus entrelasse#as_widget true
  in

  let _ = GMisc.separator `HORIZONTAL~packing:(vbox#pack ~padding:5
							 ~fill:false
							 ~expand:false
					      )
			  ()
  in

  let bottom = GPack.button_box `HORIZONTAL
				~spacing:30
				~child_width:85
				~child_height:24
				~layout:`SPREAD
				~packing:(vbox#pack ~padding:0
						    ~fill:false
						    ~expand:false
					 )
				()
  in

  let ok = GButton.button ~packing:(bottom#pack) ()
  in

  let _ = GtkBase.Widget.set_can_focus ok#as_widget true
  and _ = GtkBase.Widget.set_can_default ok#as_widget true
  and _ = ok#grab_default ()
  in

  let _ = My_controls.iconLabeled "Valider"
				  (GDraw.pixmap_from_xpm_d ~data:Icones.valid
							   ~window
							   ()
				  )
				  ~packing:ok#add
				  ()
  in

  let quit = GButton.button ~packing:(bottom#pack) ()
  in

  let _ = GtkBase.Widget.set_can_focus quit#as_widget true
  and _ = GtkBase.Widget.set_can_default quit#as_widget true
  in

  let _ = My_controls.iconLabeled "Annuler"
				  (GDraw.pixmap_from_xpm_d ~data:Icones.stop
							   ~window
							   ()
				  )
				  ~packing:quit#add
				  ()
  in



object(self)

  method window     = window
  method ok         = ok
  method quit       = quit

  method on_quitter () = window#destroy ()
  method on_window_remove (widget:GObj.widget) = self#on_quitter ()



  initializer

  (* ESC -> ferme la fentre *)
  let _ = window#event#connect#key_press ~callback:(fun (event: GdkEvent.Key.t) -> begin
										     if (GdkEvent.Key.keyval event) = GdkKeysyms._Escape
										     then
										       begin
										 	 self#on_quitter();
											 true
										       end
										     else false
										   end
						   )
  in

  let _ = ok#connect#clicked ~callback:(fun () -> f entrelasse#active;
						  self#on_quitter ()
				       )
  in

  (* Bouton retour -> ferme la fentre *)
  let _ = quit#connect#clicked ~callback:self#on_quitter
  in

  let _ = window#connect#remove  ~callback:self#on_window_remove
  in

    () 

end






class jpg_opt valeur f () =

  let window = GWindow.window ~wm_name:"Option de sauvegarde JPEG"
			      ~title:"Option de sauvegarde JPEG"
			      ~position:`CENTER
			      ~kind:`DIALOG
			      ~modal:true
			      ~allow_shrink:false
			      ~allow_grow:false
			      ~auto_shrink:false
			      ()
  in

  let vbox = GPack.vbox ~spacing:0
			~homogeneous:false
			~packing:window#add
			()
  in

  let hbox = GPack.hbox ~spacing:0
			~homogeneous:false
			~packing:(vbox#pack ~padding:10
					    ~fill:false
					    ~expand:false
				 )
			()
  in

  let _ = GMisc.label ~text:"Qualite du Jpeg :"
		      ~packing:(hbox#pack ~padding:10
					  ~fill:false
					  ~expand:false
			       )
		      ~xalign:0.5
		      ~yalign:0.5
		      ~xpad:0
		      ~ypad:0
		      ~line_wrap:false
		      ()
  in

  let quality_bar = GData.adjustment ~value:(float_of_int valeur)
				     ~lower:0.
				     ~upper:100.
				     ~step_incr:1.
				     ~page_incr:10.
				     ~page_size:0.
				     ()
  in

  let quality = GRange.scale `HORIZONTAL
			     ~adjustment:quality_bar
			     ~packing:(hbox#pack ~padding:10
						 ~fill:true
						 ~expand:true
				      )
			     ~digits:0
			     ~value_pos:`BOTTOM
			     ~draw_value:true
			     ()
  in

  let _ = quality#set_update_policy `CONTINUOUS
  and _ = GtkBase.Widget.set_can_focus quality#as_widget true
  in

  let _ = GMisc.separator `HORIZONTAL~packing:(vbox#pack ~padding:5
							 ~fill:false
							 ~expand:false
					      )
			  ()
  in

  let bottom = GPack.button_box `HORIZONTAL
				~spacing:30
				~child_width:85
				~child_height:24
				~layout:`SPREAD
				~packing:(vbox#pack ~padding:0
						    ~fill:false
						    ~expand:false
					 )
				()
  in

  let ok = GButton.button ~packing:(bottom#pack) ()
  in

  let _ = GtkBase.Widget.set_can_focus ok#as_widget true
  and _ = GtkBase.Widget.set_can_default ok#as_widget true
  and _ = ok#grab_default ()
  in

  let _ = My_controls.iconLabeled "Valider"
				  (GDraw.pixmap_from_xpm_d ~data:Icones.valid
							   ~window
							   ()
				  )
				  ~packing:ok#add
				  ()
  in

  let quit = GButton.button ~packing:(bottom#pack) ()
  in

  let _ = GtkBase.Widget.set_can_focus quit#as_widget true
  and _ = GtkBase.Widget.set_can_default quit#as_widget true
  in

  let _ = My_controls.iconLabeled "Annuler"
				  (GDraw.pixmap_from_xpm_d ~data:Icones.stop
							   ~window
							   ()
				  )
				  ~packing:quit#add
				  ()
  in



object(self)

  method window      = window
  method ok          = ok
  method quit        = quit

  method on_quitter () = window#destroy ()
  method on_window_remove (widget:GObj.widget) = self#on_quitter ()



  initializer

  (* ESC -> ferme la fentre *)
  let _ = window#event#connect#key_press ~callback:(fun (event: GdkEvent.Key.t) -> begin
										     if (GdkEvent.Key.keyval event) = GdkKeysyms._Escape
										     then
										       begin
											 self#on_quitter();
											 true
										       end
										     else false
										   end
						   )
  in

  let _ = ok#connect#clicked ~callback:(fun () -> f (int_of_float quality_bar#value);
						  self#on_quitter ()
				       )
  in

  (* Bouton retour -> ferme la fentre *)
  let _ = quit#connect#clicked ~callback:self#on_quitter
  in

  let _ = window#connect#remove  ~callback:self#on_window_remove
  in

    () 

end






class vect_opt title checked f () =

  let window = GWindow.window ~wm_name:"Option de sauvegarde PDF-PS"
			      ~title:"Option de sauvegarde PDF-PS"
			      ~position:`CENTER
			      ~kind:`DIALOG
			      ~modal:true
			      ~allow_shrink:false
			      ~allow_grow:false
			      ~auto_shrink:false
			   ()
  in

  let vbox = GPack.vbox ~spacing:0
			~homogeneous:false
			~packing:window#add
			()
  in

  let hbox = GPack.hbox ~spacing:0
			~homogeneous:false
			~packing:(vbox#pack ~padding:10
					    ~fill:false
					    ~expand:false
				 )
			()
  in

  let _ = GMisc.label ~text:"Titre :"
		      ~packing:(hbox#pack ~padding:10
					  ~fill:false
					  ~expand:false
			       )
		      ~xalign:0.5
		      ~yalign:0.5
		      ~xpad:0
		      ~ypad:0
		      ~line_wrap:false
		      ()
  in

  let titre = GEdit.entry ~text:title
			  ~packing:(hbox#pack ~padding:10
					      ~fill:true
					      ~expand:true
				   )
			  ~max_length:0
			  ~visibility:true
			  ~editable:true
			  ()
  in

  let _ = GtkBase.Widget.set_can_focus titre#as_widget true
  in

  let background = GButton.check_button ~draw_indicator:true
					~border_width:10
					~active:checked
					~label:"Intgrer l'arrire-plan  l'image"
					~packing:(vbox#pack ~padding:0
							    ~fill:false
							    ~expand:false
						 )
					()
  in

  let _ = GtkBase.Widget.set_can_focus background#as_widget true
  in

  let _ = GMisc.separator `HORIZONTAL~packing:(vbox#pack ~padding:5
							 ~fill:false
							 ~expand:false
					      )
			  ()
  in

  let bottom = GPack.button_box `HORIZONTAL
				~spacing:30
				~child_width:85
				~child_height:24
				~layout:`SPREAD
				~packing:(vbox#pack ~padding:0
						    ~fill:false
						    ~expand:false
					 )
				()
  in

  let ok = GButton.button ~packing:(bottom#pack) ()
  in

  let _ = GtkBase.Widget.set_can_focus ok#as_widget true
  and _ = GtkBase.Widget.set_can_default ok#as_widget true
  and _ = ok#grab_default ()
  in

  let _ = My_controls.iconLabeled "Valider"
				  (GDraw.pixmap_from_xpm_d ~data:Icones.valid
							   ~window
							   ()
				  )
				  ~packing:ok#add
				  ()
  in

  let quit = GButton.button ~packing:(bottom#pack) ()
  in

  let _ = GtkBase.Widget.set_can_focus quit#as_widget true
  and _ = GtkBase.Widget.set_can_default quit#as_widget true
  in

  let _ = My_controls.iconLabeled "Annuler"
				  (GDraw.pixmap_from_xpm_d ~data:Icones.stop
							   ~window
							   ()
				  )
				  ~packing:quit#add
				  ()
  in



object(self)

  method window     = window
  method ok         = ok
  method quit       = quit

  method on_quitter () = window#destroy ()
  method on_window_remove (widget:GObj.widget) = self#on_quitter ()



  initializer

  (* ESC -> ferme la fentre *)
  let _ = window#event#connect#key_press ~callback:(fun (event: GdkEvent.Key.t) -> begin
										     if (GdkEvent.Key.keyval event) = GdkKeysyms._Escape
										     then
										       begin
										 	 self#on_quitter();
											 true
										       end
										     else false
										   end
						   )
  in

  let _ = ok#connect#clicked ~callback:(fun () -> f titre#text background#active;
						  self#on_quitter ()
				       )
  in

  (* Bouton retour -> ferme la fentre *)
  let _ = quit#connect#clicked ~callback:self#on_quitter
  in

  let _ = window#connect#remove  ~callback:self#on_window_remove
  in

    () 

end
