open Types



(* Initialisation de l'aire OpenGL *)
let init_gl () = GlMisc.hint `perspective_correction `fastest;
		 GlMisc.hint `fog `fastest;
		 GlMisc.hint `polygon_smooth `fastest;
		 GlMisc.hint `point_smooth `fastest;
		 GlMisc.hint `line_smooth `fastest;

		 GlClear.color (0.9, 0.9, 0.9);
		 GlClear.depth 1.0;
		 Gl.enable `depth_test;
		 GlFunc.depth_func `lequal;
		 GlClear.clear [`color; `depth];
		 GlDraw.polygon_mode ~face:`both `fill;
		 GlDraw.cull_face `back;
		 Gl.enable `cull_face;
		 GlDraw.shade_model `smooth;
		 (*GlMisc.hint `perspective_correction `dont_care;*)
		 GlDraw.point_size 2.0;
		 GlDraw.line_width 1.0;
		 Gl.enable `point_smooth;

		 (* lumire *)
		 Gl.enable `light0;
		 GlLight.light ~num:0 (`ambient  (0.1, 0.1, 0.1, 0.0));
		 GlLight.light ~num:0 (`diffuse  (1.0, 1.0, 1.0, 0.0));
		 GlLight.light ~num:0 (`specular (0.1, 0.1, 0.1, 0.0));

		 (* brouillard :) *)
		 GlLight.fog (`mode `linear);
		 GlLight.fog (`color (0.8, 0.8, 0.8, 1.0));
		 GlLight.fog (`density 0.1);
		 (*GlMisc.hint `fog `dont_care;*)
		 GlLight.fog (`start 1.0);
		 GlLight.fog (`End 1500.0);

		 (* transparence pour les Containers *)
		 GlFunc.blend_func ~src:`src_alpha ~dst:`one_minus_src_alpha



(* fonction de mise  jour des proportions *)
let reshape ~width ~height = Parametres.width  := (float_of_int (width/100))*.100.;
			     Parametres.height := float_of_int height;
			     let ratio = !Parametres.width /. !Parametres.height
			     in
			       GlDraw.viewport 0 0 width height;
			       Move.set_perspective ()
