/* TODO : commenter le fichier */
/* TODO : vrifier la cohrence des valeurs (ex. : hauteur>=0.) */


/*
 * Exceptions   rattraper :  - ParseError 'string' : 'string' reprsente le messge d'erreur  afficher
 */


%{

open Types
open Triplet



exception PolygonePlat



let parse_error s = raise (ParseError s)



(* Ordonne la liste des points d'un polygone et calcule la normale *)
let ordonnePointsPolygone lst =
  let lst = List.map (fun pt -> pt#getAll) lst in
    try
      let ptIntern =
	let rec sum pt size l =
	  match l with
	    | []   -> pt, size
	    | t::q -> sum (add_triplet pt t) (size +. 1.) q
	in
	let (pt, size) = sum (0., 0., 0.)  0.  lst in
	  div_triplet pt size
      in
      
      let vect1 = normalise_triplet (diff_triplet (List.hd lst) ptIntern)
      and norme =
	let rec f l = match l with
	  | []   -> raise PolygonePlat
	  | t::q -> (
	      let n = prod_triplet
			(diff_triplet (List.hd lst) ptIntern)
			(diff_triplet t             ptIntern)
	      in
		match n with
		  | (0., 0., 0.) -> f q
		  | _            -> n
	    )
	in
	  normalise_triplet (f (List.tl lst))
      in
			    let fnAngle ptI = let vectI = normalise_triplet (diff_triplet ptI ptIntern)
						      in
						      let sinus = scalaire (prod_triplet vect1 vectI) norme
						      and cosPositif = (scalaire vect1 vectI) >= 0.
						      in
							if cosPositif
							then sinus
							else 2. -. sinus
				    in
				    let lstAngle = List.map (fun pt -> fnAngle pt, pt) lst
				    in
				    let lstOrdonne = List.sort (fun (theta1, _) -> fun (theta2, _) -> if theta1 < theta2
												      then -1
												      else (if theta1 = theta2
													    then 0
													    else 1
													   )
							       ) lstAngle
				    in

				    let lstConvexe = let testConvexe p1 p2 p3 = (scalaire (prod_triplet (diff_triplet p2 p1)
													(diff_triplet p3 p2))
											  norme
										) > 0.
						     and marque = ref (None:(float * float * float) option)
						     and cycle = let f = new File.file
								 in
								   List.iter (fun (_, pt) -> f#pushEnd pt) lstOrdonne;
								   f
						     in
						     let test cycl = let p1 = cycl#popBegin ()
								     and p2 = cycl#popBegin ()
								     and p3 = cycl#popBegin ()
								     in
								       if testConvexe p1 p2 p3
								       then
									 begin
									   cycl#pushEnd p1;
									   cycl#pushBegin p3;
									   cycl#pushBegin p2;
									   match !marque
									   with
									     | None   -> marque := Some p2;
											 true
									     | Some p -> p <> p3
									 end
								       else
									 begin
									   marque := None;
									   let pEnd = cycl#popEnd ()
									   in
									     cycl#pushBegin p3;
									     cycl#pushBegin p1;
									     cycl#pushBegin pEnd;
									     false
									 end
						     in
						     let rec toList cycl = try
									     let pt = cycl#popBegin ()
									     in
									       pt::(toList cycl)
									   with
									     | File.FileVide -> []
						     in
						       while test cycle
						       do
							 ()
						       done;
						       toList cycle
				    in
(*				      (List.map (fun (_, pt) -> triplet2point pt) lstOrdonne), triplet2point norme*)
				      (List.map triplet2point lstConvexe), triplet2point norme
    with
      | PolygonePlat -> match lst
	with
							| []    ->  [], new point 1. 0. 0.
							| p::[] -> [triplet2point p], new point 1. 0. 0.
							| t::q  -> let pExtrem = let rec f p n l = match l
												   with
												     | []   -> p
												     | t::q -> let nT = normale_carre_triplet t
													       in
														 if nT > n
														 then f t nT q
														 else f p n q
										 in
										 let n = normale_triplet t
										 in
										   f t n q
								   in
								   let pExtrem2 = let rec f p n l = match l
												    with
												      | []   -> p
												      | t::q -> let nT = normale_carre_triplet (diff_triplet t pExtrem)
														in
														  if nT > n
														  then f t nT q
														  else f p n q
										  in
										  let n = normale_triplet (diff_triplet t pExtrem)
										  in
										    f t n q
								   in
								   let norme = let (x, y, z) = diff_triplet pExtrem2 pExtrem
									       in
										 (-.y, x, 0.)
								   in
								     [triplet2point pExtrem ; triplet2point pExtrem2], triplet2point norme



(* Transmet la couleur de ensembles d'objets *)
let rec trans_couleur color obj = match obj
				  with
				    | Vide -> ()

				    | Primitive (_, coul, _, cont) -> if coul#isDefault
								      then
									coul#setAll color#getAll;
								      (match cont
								       with
									 | None             -> ()
									 | Some (_, _, lst) -> List.iter (trans_couleur color) lst
								      )
				    | Transformation (_, objTrans) -> trans_couleur color objTrans

				    | Groupe (coul, objGrp) -> if coul#isDefault
							       then
								 coul#setAll color#getAll;
							       List.iter (trans_couleur coul) objGrp

				    | Grid (_, _, coul, objList) -> if coul#isDefault
								    then
								      coul#setAll color#getAll;
								    List.iter (function (obj, _) -> trans_couleur coul obj) objList



(* Duplique une GridList *)
let rec copyGridList objList = List.map (function (obj, pt) -> (copyObjet obj, Oo.copy pt)) objList



(* Duplique un objet *)
and copyObjet obj =
  match obj
  with
    | Vide                   -> Vide
    | Primitive (prim, coul, wire, cont) ->
	let newCoul = Oo.copy coul
	and newPrim = (match prim
		       with
			 | Box pt                      ->
			     let newPt = Oo.copy pt
			     in Box newPt
			 | Cone (r, h, solid, n)       -> Cone (ref !r, ref !h, ref !solid, ref !n)
			 | Cylinder (r, h, solid, n)   -> Cylinder (ref !r, ref !h, ref !solid, ref !n)
			 | Disc (r, n)                 -> Disc (ref !r, ref !n)
			 | Empty (pt, v)               ->
			     let newPt = Oo.copy pt
			     in
			       Empty (newPt, ref !v)
			 | Frustum (r, h, t, solid, n) -> Frustum (ref !r, ref !h, ref !t, ref !solid, ref !n)
			 | Polygone (l, n)             -> Polygone (ref (List.map Oo.copy !l), Oo.copy n)
			 | Polyline l                  -> Polyline (ref (List.map Oo.copy !l))
			 | Sphere (r, n, m)            -> Sphere (ref !r, ref !n, ref !m)
			 | String pxmp               -> String (ref (GlPix.of_raw
								       (GlPix.to_raw !pxmp)
								       (GlPix.format !pxmp)
								       (GlPix.width  !pxmp)
								       (GlPix.height !pxmp))
							       )
		      )
	and newCont = (match cont
		       with
			 | None             -> None
			 | Some (c, h, lst) -> Some (Oo.copy c, ref !h, List.map copyObjet lst)
		      )
	in
	  Primitive (newPrim, newCoul, wire, newCont)
	    
    | Transformation (trans, objTrans) ->
	let newObj   = copyObjet objTrans
	and newTrans = (match trans
			with
			  | Rotation (axis, angle) -> Rotation (axis, angle)
			  | Scale pt               ->
			      let newPt = Oo.copy pt
			      in
				Scale newPt
			  | Translation pt         ->
			      let newPt = Oo.copy pt
			      in
				Translation newPt
		       )
	in
	  Transformation (newTrans, newObj)
	    
    | Groupe (coul, objGrp) ->
	let newObjLst = List.map copyObjet objGrp
	and newCoul   = Oo.copy coul
	in
	  Groupe (newCoul, newObjLst)
	    
    | Grid (pt, grid, coul, objList) ->
	let newPt   = Oo.copy pt
	and newCoul = Oo.copy coul
	and newObj  = copyGridList objList
	and newGrid = (match grid
		       with
			 | Grid0 (x, y, z)                         -> Grid0 (x, y, z)
			 | Grid1 (w, x, y, z)                      -> Grid1 (w, x, y, z)
			 | Grid2 (r, s, t, u, v, w, x, y, z)       -> Grid2 (r, s, t, u, v, w, x, y, z)
			 | Grid3 (p, q, r, s, t, u, v, w, x, y, z) -> Grid3 (p, q, r, s, t, u, v, w, x, y, z)
			 | Hexa2 (u, v, w, x, y, z)                -> Hexa2 (u, v, w, x, y, z)
			 | Hexa3 (u, v, w, x, y, z)                -> Hexa3 (u, v, w, x, y, z)
		      )
	in
	  Grid (newPt, newGrid, newCoul, newObj)



(* Insre dans lst l'lment (str, obj) en respectant l'ordre alphabtique sur str *)
let rec insertAlpha str obj lst = match lst 
				  with
				    | []	-> (str, obj)::[]
				    | (t, o)::q -> if t<str
						   then (t, o)::(insertAlpha str obj q)
						   else if t=str
							then raise (ParseError ("redfinition de l'objet " ^ str))
							else (str, obj)::(t, o)::q



(* Duplique l'objet de nom "str" de la liste lst *)
let rec copyObjetAlpha str lst = match lst
				 with
				   | []	-> raise (ParseError ("l'objet " ^ str ^ " n'est pas dfini"))
				   | (t, o)::q -> if t<str
						  then copyObjetAlpha str q
						  else if (t=str)
						       then copyObjet o
						       else raise (ParseError ("l'objet " ^ str ^ " n'est pas dfini"))



(* Retourne la scne de de la liste scn_lst ayant le nom "str" *)
let rec string2scene scn_lst str = match scn_lst
				   with
				     | []	   -> raise (ParseError ("la scne " ^ str ^ " n'est pas dfinie"))
				     | (nom, sc)::q -> if (nom < str)
						       then string2scene q str
						       else if (nom = str)
							    then sc
							    else raise (ParseError ("la scne " ^ str ^ " n'est pas dfinie"))






(* Gnre un pixmap  partir d'un text, d'une taille, d'une police, d'une dpi et d'une couleur *)
let generatePix text size ttf dpi color alpha =
  let face = new OFreetype.face ttf 0 in
    face#set_char_size size size dpi dpi;
    (*begin 
      try face#set_charmap { Freetype.platform_id= 3; Freetype.encoding_id= 1 } with | _ -> 
      try face#set_charmap { Freetype.platform_id= 3; Freetype.encoding_id= 0 } with | _ ->
      face#set_charmap (List.hd face#charmaps)
      end;*)
    let smetrics = face#size_metrics in
      
    let plus = 8 in
    let encoded = Fttext.unicode_of_latin text in
    let x1,y1,x2,y2 = face#size encoded in
    let h = truncate (ceil y2) - truncate y1 + 1 + plus in
    let w = truncate (x2 -. x1) + plus in

    let fg = { Color.color = { Color.r = truncate(255.*.color#getRouge);
			       Color.g = truncate(255.*.color#getVert);
			       Color.b = truncate(255.*.color#getBleu)
			     } ; Color.alpha = truncate(255.*.alpha) } in
    let bg = { Color.color = { Color.r = 255-fg.Color.color.Color.r; Color.g = 255-fg.Color.color.Color.g; Color.b = 255-fg.Color.color.Color.b } ; Color.alpha = 0 } in

    let rgb = new OImage.rgba32_filled w h bg in
      OFreetype.draw_text face
	(fun org level ->
  	   let level' = 255 - level in
  	     { Color.color = { Color.r = (org.Color.color.Color.r * level'
					  + fg.Color.color.Color.r * level) / 255;
  			       Color.g = (org.Color.color.Color.g * level'
					  + fg.Color.color.Color.g * level) / 255;
  			       Color.b = (org.Color.color.Color.b * level'
					  + fg.Color.color.Color.b * level) / 255 } ;
	       Color.alpha = (org.Color.alpha * level'
			      + fg.Color.alpha * level) / 255 }
	)
  	(rgb :> Color.rgba OImage.map) (plus / 2 - (truncate x1))
	(truncate y2 + plus / 2) encoded;

      let raw = Raw.create `float ~len:(w*h*4) in
	for j = 0 to (h-1) do
	  for i = 0 to (w-1) do
	    let color = rgb#get i j in
	      Raw.sets_float raw ~pos:(((h-1-j)*w+i)*4)
		[| (float_of_int color.Color.color.Color.r) /. 255.0 ; 
		   (float_of_int color.Color.color.Color.g) /. 255.0 ; 
		   (float_of_int color.Color.color.Color.b) /. 255.0 ; 
		   (float_of_int color.Color.alpha) /. 255.0 |]
	      ;
	      ()
	  done
	done;
	let pxmp = ((GlPix.of_raw raw
		       ~format:`rgba
		       ~width:w
		       ~height:h
		    ):([`rgba], [`float]) GlPix.t)
		     
	in
	  pxmp


%}


  /***************/
 /* Token typs */
/***************/


%token <string>     TokNOM
%token <string>     TokSTR
%token <float>      TokNOMBRE
%token <bool>       TokBOOL
%token <string>     TokCOMMAND




  /*****************/
 /* Token simples */
/*****************/


%token              TokVirgule
%token              TokDebAccol
%token              TokFinAccol
%token              TokDebCrochet
%token              TokFinCrochet
%token              TokInf
%token              TokSup
%token              Tok2points

%token              TokBox
%token              TokCone
%token              TokCylinder
%token              TokDisc
%token              TokFrustum
%token              TokSphere
%token              TokPolygone
%token              TokPolyline
%token              TokEmpty
%token              TokLine
%token              TokString

%token              TokTranslated
%token              TokScaled
%token              TokAxisRotated

%token              TokGroup
%token              TokGrid0
%token              TokGrid1
%token              TokGrid2
%token              TokGrid3
%token              TokHexa2
%token              TokHexa3

%token              TokColor

%token              TokTextured

%token              TokSize
%token              TokRadius
%token              TokHeight
%token              TokSolid
%token              TokSlices
%token              TokTaper
%token              TokStacks
%token              TokPointList
%token              TokText

%token              TokTranslation
%token              TokScale
%token              TokAxis
%token              TokAngle
%token              TokGeometry

%token              TokVisible

%token              TokStartPoint
%token              TokSpace
%token              TokSpace1
%token              TokSpace2
%token              TokSpace3
%token              TokLineUp1
%token              TokLineUp2
%token              TokLineUp3
%token              TokRatio

%token              TokGridList

%token              TokLeft
%token              TokMiddle
%token              TokRight

%token              TokType
%token              TokOpacity
%token              TokContain
%token              TokDraw

%token              TokBlend
%token              TokClose
%token              TokHalf
%token              TokMixed
%token              TokNone
%token              TokOpen
%token              TokWire
%token              TokUp
%token              TokDown

%token              TokFin

%token              TokAxisX
%token              TokAxisY
%token              TokAxisZ

%token              TokAxis1
%token              TokAxis2

%token              TokDef
%token              TokScene
%token              TokShow
%token              TokHide
%token              TokReplace
%token              TokPlay
%token              TokExec
%token              TokPause

%token              TokView
%token              TokAuto
%token              TokVertical
%token              TokCenter
%token              TokViewer

%token              TokMove
%token              TokSpin
%token              TokRotation
%token              TokDeltaX
%token              TokDeltaY
%token              TokDeltaZ
%token                TokSpeedX
%token              TokSpeedY
%token            TokSpeedZ




  /*******************/
 /* Rgle de dpart */
/*******************/


%start file
%start std
%type  <unit> file
%type  <bool> std



%%



file:
    definitions scenes TokFin
      {
	clear_parser ()
      }
  | scenes TokFin
      {
	clear_parser ()
      }



std:
    definitions
      {
	clear_parser ();
	true
      }
  | scen
      {
	clear_parser ();
	true
      }
  | command
      {
	clear_parser ();
	true
      }
  | TokFin
      {
	clear_parser ();
	false
      }




  /**********/
 /* Scenes */
/**********/


scenes: 
    TokFin
      { () }
  | scen scenes
      { () }
  | command scenes
      { () }



scen:
    TokScene TokDebAccol scen_body TokFinAccol 
      {
	Scene.add_scene $3
      }
  | TokScene TokNOM TokDebAccol scen_body TokFinAccol
      {
	$4#setName $2;
	Parametres.sceneLst := insertAlpha $2 $4 !Parametres.sceneLst;
	Scene.add_scene $4
      }



scen_body:
  /* Rien */
      {             
	new scene
      }
  
  | objt scen_body
      {
	trans_couleur (new couleur 0.2 0.2 0.2 1.) $1;
	let newContenu = $1::($2#getContenu)
	in
	  $2#setContenu newContenu;
	  $2
      }




  /*************/
 /* Commandes */
/*************/


command:
    TokShow scene_list
      {
	Scene.add_command (Show (List.map (string2scene !Parametres.sceneLst) $2))
      }
  | TokHide scene_list
      {
	Scene.add_command (Hide (List.map (string2scene !Parametres.sceneLst) $2))
      }
  | TokView TokDebAccol cmd_view TokFinAccol
      {
	Scene.add_command $3
      }
  | TokReplace TokDebAccol replace TokFinAccol
      {
	Scene.add_command $3
      }
  | TokPause
      {
	Scene.add_command Pause
      }
  | TokExec TokCOMMAND
      {
	Scene.add_command (Command $2)
      }
  | TokMove TokDebAccol mvt TokFinAccol
      {
	let ((tv, td), (rv, rd), (sv, sd)) = $3
	and verifie vitesse delta = let verif d v = if (d <> 0.) && (v = 0.)
						    then raise (ParseError ("la vitesse et l'amplitude du mouvement ne concordent pas"))
				    in
				      verif (abscisse delta) (abscisse vitesse);
				      verif (ordonnee delta) (ordonnee vitesse);
				      verif (cote     delta) (cote     vitesse)
	in
	  verifie tv td;
	  verifie rv rd;
	  verifie sv sd;
	  let move = new mouvement
	  in
	    (move#transSpeed)#setAll tv;
	    (move#transDelta)#setAll td;
	    (move#  rotSpeed)#setAll rv;
	    (move#  rotDelta)#setAll rd;
	    (move# spinSpeed)#setAll sv;
	    (move# spinDelta)#setAll sd;
	    Scene.add_command (Movement move)
      }



cmd_view:
    TokAuto
      {
	View (AutoViewer, AutoCenter, AutoVertical)
      }
  | view_body
      {
	let (x, y, z) = $1
	in
	  View (x, y, z)
      }



replace:
    replace_hide TokShow scene_list replace_hide
      {
	Replace ((match ($1, $4)
		  with
		    | None, None       -> None
		    | None, Some l     -> Some l
		    | Some l, None     -> Some l
		    | Some l1, Some l2 -> Some (l1 @ l2))
		 , (List.map (string2scene !Parametres.sceneLst) $3))
      }



replace_hide:
  /* rien */
      {
	None
      }
  | TokHide scene_list
      {
	Some (List.map (string2scene !Parametres.sceneLst) $2)
      }



mvt:
  /* rien */
      {
	(((1., 1., 1.), (0., 0., 0.)), ((1., 1., 1.), (0., 0., 0.)), ((1., 1., 1.), (0., 0., 0.)))
      }
  | TokTranslation mvt_body mvt
      {
	let (_, r, s) = $3
	in
	  ($2, r, s)
      }
  | TokRotation    mvt_body mvt
      {
	let (t, _, s) = $3
	in
	  (t, $2, s)
      }
  | TokSpin        mvt_body mvt
      {
	let (t, r, _) = $3
	in
	  (t, r, $2)
      }




  /***************/
 /* Dfinitions */
/***************/


definitions:
  TokDef TokDebAccol definitions_body TokFinAccol
      { () }



definitions_body:
  /* rien */
      { () }
  | definition definitions_body
      { () }



definition:
  definition_body
      {
	let (nom, obj) = $1
	in
	  Parametres.dico := (insertAlpha nom obj !Parametres.dico);
	  obj
      }



definition_body:
    def_primitiv	{ $1 }
  | def_transform       { $1 }
  | def_group           { $1 }
  | def_grid            { $1 }



def_primitiv:
    def_box             { $1 }
  | def_cone            { $1 }
  | def_cylindre        { $1 }
  | def_disque          { $1 }
  | def_frustum         { $1 }
  | def_sphere          { $1 }
  | def_polygone        { $1 }
  | def_polyline        { $1 }
  | def_empty           { $1 }
  | def_string          { $1 }



def_transform:
    def_translation     { $1 }
  | def_scale           { $1 }
  | def_rotation        { $1 }



def_grid:
    TokGrid0 def_grid0  { $2 }
  | TokGrid1 def_grid1  { $2 }
  | TokGrid2 def_grid2  { $2 }
  | TokGrid3 def_grid3  { $2 }
  | TokHexa2 def_hexa2  { $2 }
  | TokHexa3 def_hexa3  { $2 }



def_box:
/* Dfinition d'une nouvelle Box */
  TokBox TokNOM TokDebAccol box_body
      {
	let node = let (size, color, wire, cont) = $4
		   in
		     Primitive (Box size, color, ref wire, cont)
	in
	  ($2, node)
      }

def_string:
/* Dfinition d'une nouvelle String */
  TokString TokNOM TokDebAccol string_body
      {
	(let node =
	   let (size, color, text, wire) = $4 in
	   let alpha = match wire with Blend a -> a | _ -> 1.0 in
	   let pxmp = generatePix text size (!Parametres.defaultTtf) (!Parametres.defaultDpi) color alpha in
	     Primitive (String (ref pxmp), color, ref wire, None)
	 in
	   ($2, node)
	)
      }



def_cone:
/* Dfinition d'un nouveau Cone */
  TokCone TokNOM TokDebAccol cone_body
      {
	let node = let (rayon, hauteur, solide, slice, color, wire, cont) = $4
		   in
		     Primitive (Cone (ref rayon, ref hauteur, ref solide, ref slice), color, ref wire, cont)
	in
	  ($2, node)
      }



def_cylindre:
/* Dfinition d'un nouveau Cylinder */
  TokCylinder TokNOM TokDebAccol cylindre_body
      {
	let node = let (rayon, hauteur, solide, slice, color, wire, cont) = $4
		   in
		     Primitive (Cylinder (ref rayon, ref hauteur, ref solide, ref slice), color, ref wire, cont)
	in
	  ($2, node)
      }



def_disque:
/* Dfinition d'un nouveau Disc */
  TokDisc TokNOM TokDebAccol disque_body
      {
	let node = let (rayon, slice, color, wire) = $4
		   in
		     Primitive (Disc (ref rayon, ref slice), color, ref wire, None)
	in
	  ($2, node)
      }



def_frustum:
/* Dfinition d'un nouveau Frustum */
  TokFrustum TokNOM TokDebAccol frustum_body
      {
	let node = let (rayon, hauteur, rate, solide, slice, color, wire, cont) = $4
		   in
		     Primitive (Frustum (ref rayon, ref hauteur, ref rate, ref solide, ref slice), color, ref wire, cont)
	in
	  ($2, node)
      }



def_sphere:
/* Dfinition d'une nouvelle Sphere */
  TokSphere TokNOM TokDebAccol sphere_body
      {
	let node = let (rayon, slice, stack, color, wire, cont) = $4
		   in
		     Primitive (Sphere (ref rayon, ref slice, ref stack), color, ref wire, cont)
	in
	  ($2, node)
      }



def_polyline:
/* Dfinition d'un nouveau Polyline */
  TokPolyline TokNOM TokDebAccol polyline_body
      {
	let node = let (liste, color, wire) = $4
		   in
		     Primitive (Polyline (ref liste), color, ref wire, None)
	in
	  ($2, node)
      }



def_polygone:
/* Dfinition d'un nouveau Polygone */
  TokPolygone TokNOM TokDebAccol polyline_body
      {
	let node = let (liste, color, wire) = $4
		   in
		   let (lst, norme) = ordonnePointsPolygone liste
		   in
		     Primitive (Polygone (ref lst, norme), color, ref wire, None)
	in
	  ($2, node)
      }



def_empty:
/* Dfinition d'un nouveau Empty */
  TokEmpty TokNOM TokDebAccol empty_body
      {
	let node = let (size, visible, color, wire, cont) = $4
		   in
		     Primitive (Empty (size, ref visible), color, ref wire, cont)
	in
	  ($2, node)
      }



def_translation:
/* Dfinition d'une nouvelle Translation */
  TokTranslated TokNOM TokDebAccol translation_body
      {
	($2, $4)
      }



def_scale:
/* Dfinition d'une nouvelle homothtie */
  TokScaled TokNOM TokDebAccol scale_body
      {
	($2, $4)
      }



def_rotation:
/* Dfinition d'une nouvelle Rotation */
  TokAxisRotated TokNOM TokDebAccol rotation_body
      {
	let (axis, x, angle, y, obj, z) = $4
	in
	let node = (if x && y && z
		    then Transformation (Rotation (axis, angle), obj)
		    else raise (ParseError "la rotation est incomplte")
		   )
	in
	  ($2, node)
      }



def_group:
/* Dfinition d'un nouveau Group */
  TokGroup TokNOM TokDebAccol group_body
      {
	let node = let (obj, color) = $4
		   in
		     Groupe (color, obj)
	in
	  ($2, node)
      }



def_grid0:
/* Dfinition d'un nouveau Grid0 */
  TokNOM TokDebAccol grid0_body
      {
	let node = let (pt, alignX, alignY, alignZ, coul, lst) = $3
		   in
		     Grid (pt, Grid0 (alignX, alignY, alignZ), coul, lst)
	in
	  ($1, node)
      }



def_grid1:
/* Dfinition d'un nouveau Grid1 */
  TokNOM TokDebAccol grid1_body
      {
	let node = let (pt, axis, align1, align2, space1, coul, lst) = $3
		   in
		     Grid (pt, Grid1 (axis, align1, align2, space1), coul, lst)
	in
	  ($1, node)
      }



def_grid2:
/* Dfinition d'un nouveau Grid2 */
  TokNOM TokDebAccol grid2_body
      {
	($1, Create_grid.create_grid2 $3)
      }



def_grid3:
/* Dfinition d'un nouveau Grid3 */
  TokNOM TokDebAccol grid3_body
      {
	($1, Create_grid.create_grid3 $3)
      }



def_hexa2:
/* Dfinition d'un Grid hxagonal 2D */
  TokNOM TokDebAccol hexa2_body
      {
	($1, Create_grid.create_hexa2 $3)
      }



def_hexa3:
/* Dfinition d'un Grid hxagonal 3D */
  TokNOM TokDebAccol hexa3_body
      {
	($1, Create_grid.create_hexa3 $3)
      }




  /**********/
 /* Objets */
/**********/


objt:
    primitiv        { $1 }
  | transform       { $1 }
  | group           { $1 }
  | grid            { $1 }
  | definition      { $1 }
  | TokNOM          { copyObjetAlpha $1 !Parametres.dico }



primitiv:
    box             { $1 }
  | cone            { $1 }
  | cylindre        { $1 }
  | disque          { $1 }
  | frustum         { $1 }
  | sphere          { $1 }
  | polygone        { $1 }
  | polyline        { $1 }
  | empty           { $1 }
  | string          { $1 }



transform:
    translation     { $1 }
  | scale           { $1 }
  | rotation        { $1 }



grid:
    TokGrid0 grid0  { $2 }
  | TokGrid1 grid1  { $2 }
  | TokGrid2 grid2  { $2 }
  | TokGrid3 grid3  { $2 }
  | TokHexa2 hexa2  { $2 }
  | TokHexa3 hexa3  { $2 }




  /********************/
 /* Objets Primitifs */
/********************/


box:
  TokBox TokDebAccol box_body
      {
	let (size, color, wire, cont) = $3
	in
	  Primitive (Box size, color, ref wire, cont)
      }



string:
  TokString TokDebAccol string_body
      {
	let (size, color, text, wire) = $3 in
	let alpha = match wire with Blend a -> a | _ -> 1.0 in
	let pxmp = generatePix text size (!Parametres.defaultTtf) (!Parametres.defaultDpi) color alpha in
	  Primitive (String (ref pxmp), color, ref wire, None)
      }



cone:
  TokCone TokDebAccol cone_body
      {
	let (rayon, hauteur, solide, slice, color, wire, cont) = $3
	in
	  Primitive (Cone (ref rayon, ref hauteur, ref solide, ref slice), color, ref wire, cont)
      }



cylindre:
  TokCylinder TokDebAccol cylindre_body
      {
	let (rayon, hauteur, solide, slice, color, wire, cont) = $3
	in
	  Primitive (Cylinder (ref rayon, ref hauteur, ref solide, ref slice), color, ref wire, cont)
      }



disque:
  TokDisc TokDebAccol disque_body
      { 
	let (rayon, slice, color, wire) = $3
	in
	  Primitive (Disc (ref rayon, ref slice), color, ref wire, None)
      }



frustum:
  TokFrustum TokDebAccol frustum_body
      {
	let (rayon, hauteur, rate, solide, slice, color, wire, cont) = $3
	in
	  Primitive (Frustum (ref rayon, ref hauteur, ref rate, ref solide, ref slice), color, ref wire, cont)
      }



sphere:
  TokSphere TokDebAccol sphere_body
      {
	let (rayon, slice, stack, color, wire, cont) = $3
	in
	  Primitive (Sphere (ref rayon, ref slice, ref stack), color, ref wire, cont)
      }



polygone:
  TokPolygone TokDebAccol polyline_body
      {
	let (liste, color, wire) = $3
	in
	let (lst, norme) = ordonnePointsPolygone liste
	in
	  Primitive (Polygone (ref lst, norme), color, ref wire, None)
      }



polyline:
  TokPolyline TokDebAccol polyline_body
      {
	let (liste, color, wire) = $3
	in
	  Primitive (Polyline (ref liste), color, ref wire, None)
      }



empty:
  TokEmpty TokDebAccol empty_body
      {
	let (size, visible, color, wire, cont) = $3
	in
	  Primitive (Empty (size, ref visible), color, ref wire, cont)
      }




  /******************/
 /* Tansformations */
/******************/


translation:
  TokTranslated TokDebAccol translation_body
      { $3 }



scale:
  TokScaled TokDebAccol scale_body
      { $3 }



rotation:
  TokAxisRotated TokDebAccol rotation_body
      {
	let (axis, x, angle, y, obj, z) = $3
	in
	  if x && y && z then Transformation (Rotation (axis, angle), obj)
	  else raise (ParseError "la rotation est incomplte")
      }




  /***********/
 /* Groupes */
/***********/


group:
  TokGroup TokDebAccol group_body
      {
	let (obj, color) = $3
	in
	  Groupe (color, obj)
      }




  /*********/
 /* Grids */
/*********/


grid0:
  TokDebAccol grid0_body
      {
	let (pt, alignX, alignY, alignZ, coul, lst) = $2
	in
	  Grid (pt, Grid0 (alignX, alignY, alignZ), coul, lst)
      }



grid1:
  TokDebAccol grid1_body
      {
	let (pt, axis, align1, align2, space1, coul, lst) = $2
	in
	  Grid (pt, Grid1 (axis, align1, align2, space1), coul, lst)
      }



grid2:
  TokDebAccol grid2_body
      {
	Create_grid.create_grid2 $2
      }



grid3:
  TokDebAccol grid3_body
      {
	Create_grid.create_grid3 $2
      }



hexa2:
  TokDebAccol hexa2_body
      {
	Create_grid.create_hexa2 $2
      }



hexa3:
  TokDebAccol hexa3_body
      {
	Create_grid.create_hexa3 $2
      }




  /************/
 /* Les body */
/************/


box_body:
    TokFinAccol
      {
	(new point nan nan nan), (new couleur nan nan nan nan), Close, None
      }
  | TokSize vect box_body
      {
	let (_, x, y, z) = $3
	in
	  ($2, x, y, z)
      }
  | TokColor color box_body
      {
	let (w, _, y, z) = $3
	in
	  (w, $2, y, z)
      }
  | TokDraw draw box_body
      {
	let (w, x, _, z) = $3
	in
	  (w, x, $2, z)
      }
  | TokContain TokDebCrochet objt_list box_body
      {
	let (w, x, y, _) = $4
	in
	  (w, x, y, Some (new point nan nan nan, ref 1., $3))
      }



string_body:
    TokFinAccol
      {
	10.0, (new couleur nan nan nan nan), "Default", (Blend 1.0)
      }

  | TokSize TokNOMBRE string_body
      {
	let (_, x, y, a) = $3
	in
	  ($2, x, y, a)
      }

  | TokText TokSTR string_body
      {
	let (x, y, _, a) = $3
	in
	  (x, y, $2, a)
      }

  | TokColor color string_body
      {
	let (w, _, y, a) = $3
	in
	  (w, $2, y, a)
      }

  | TokDraw draw string_body
      {
	let (w, x, z, _) = $3
	in
	  (w, x, z, $2)
      }


cone_body:
    TokFinAccol
      {
	nan, nan, true, 16, (new couleur nan nan nan nan), Close, None
      }
  | TokRadius TokNOMBRE cone_body
      {
	let (_, u, v, w, x, y, z) = $3
	in
	  ($2, u, v, w, x, y, z)
      }
  | TokHeight TokNOMBRE cone_body
      {
	let (t, _, v, w, x, y, z) = $3
	in
	  (t, $2 /. 2., v, w, x, y, z)
      }
  | TokSolid TokBOOL cone_body
      {
	let (t, u, _, w, x, y, z) = $3
	in
	  (t, u, $2, w, x, y, z)
      }
  | TokSlices TokNOMBRE cone_body
      {
	let (t, u, v, _, x, y, z) = $3
	in
	  (t, u, v, int_of_float $2, x, y, z)
      }
  | TokColor color cone_body
      {
	let (t, u, v, w, _, y, z) = $3
	in
	  (t, u, v, w, $2, y, z)
      }
  | TokDraw draw cone_body
      {
	let (t, u, v, w, x, _, z) = $3
	in
	  (t, u, v, w, x, $2, z)
      }
  | TokContain TokDebCrochet objt_list cone_body
      {
	let (t, u, v, w, x, y, _) = $4
	in
	  (t, u, v, w, x, y, Some (new point nan nan nan, ref 1., $3))
      }



cylindre_body:
    TokFinAccol
      {
	nan, nan, true, 16, (new couleur nan nan nan nan), Close, None
      }
  | TokRadius TokNOMBRE cylindre_body
      {
	let (_, u, v, w, x, y, z) = $3
	in
	  ($2, u, v, w, x, y, z)
      }
  | TokHeight TokNOMBRE cylindre_body
      {
	let (t, _, v, w, x, y, z) = $3
	in
	  (t, $2 /. 2., v, w, x, y, z)
      }
  | TokSolid TokBOOL cylindre_body
      {
	let (t, u, _, w, x, y, z) = $3
	in
	  (t, u, $2, w, x, y, z)
      }
  | TokSlices TokNOMBRE cylindre_body
      {
	let (t, u, v, _, x, y, z) = $3
	in
	  (t, u, v, int_of_float $2, x, y, z)
      }
  | TokColor color cylindre_body
      {
	let (t, u, v, w, _, y, z) = $3
	in
	  (t, u, v, w, $2, y, z)
      }
  | TokDraw draw cylindre_body
      {
	let (t, u, v, w, x, _, z) = $3
	in
	  (t, u, v, w, x, $2, z)
      }
  | TokContain TokDebCrochet objt_list cylindre_body
      {
	let (t, u, v, w, x, y, _) = $4
	in
	  (t, u, v, w, x, y, Some (new point nan nan nan, ref 1., $3))
      }



disque_body:
    TokFinAccol
      {
	1., 16, (new couleur nan nan nan nan), Close
      }
  | TokRadius TokNOMBRE disque_body
      {
	let (_, x, y, z) = $3
	in
	  ($2, x, y, z)
      }
  | TokSlices TokNOMBRE disque_body
      {
	let (w, _, y, z) = $3
	in
	  (w, int_of_float $2, y, z)
      }
  | TokColor color disque_body
      {
	let (w, x, _, z) = $3
	in
	  (w, x, $2, z)
      }
  | TokDraw draw disque_body
      {
	let (w, x, y, _) = $3
	in
	  (w, x, y, $2)
      }



frustum_body:
    TokFinAccol
      {
	nan, nan, nan, true, 16, (new couleur nan nan nan nan), Close, None
      }
  | TokRadius TokNOMBRE frustum_body
      {
	let (_, t, u, v, w, x, y, z) = $3
	in
	  ($2, t, u, v, w, x, y, z)
      }
  | TokHeight TokNOMBRE frustum_body
      {
	let (s, _, u, v, w, x, y, z) = $3
	in
	  (s, $2 /. 2., u, v, w, x, y, z)
      }
  | TokTaper TokNOMBRE frustum_body
      {
	let (s, t, _, v, w, x, y, z) = $3
	in
	  (s, t, $2, v, w, x, y, z)
      }
  | TokSolid TokBOOL frustum_body
      {
	let (s, t, u,  _, w, x, y, z) = $3
	in
	  (s, t, u, $2, w, x, y, z)
      }
  | TokSlices TokNOMBRE frustum_body
      {
	let (s, t, u, v, _, x, y, z) = $3
	in
	  (s, t, u, v, int_of_float $2, x, y, z)
      }
  | TokColor color frustum_body
      {
	let (s, t, u, v, w, _, y, z) = $3
	in
	  (s, t, u, v, w, $2, y, z)
      }
  | TokDraw draw frustum_body
      {
	let (s, t, u, v, w, x, _, z) = $3
	in
	  (s, t, u, v, w, x, $2, z)
      }
  | TokContain TokDebCrochet objt_list frustum_body
      {
	let (s, t, u, v, w, x, y, _) = $4
	in
	  (s, t, u, v, w, x, y, Some (new point nan nan nan, ref 1., $3))
      }



sphere_body:
    TokFinAccol
      {
	nan, 16, 16, (new couleur nan nan nan nan), Close, None
      }
  | TokRadius TokNOMBRE sphere_body
      {
	let (_, v, w, x, y, z) = $3
	in
	  ($2, v, w, x, y, z)
      }
  | TokSlices TokNOMBRE sphere_body
      {
	let (u, _, w, x, y, z) = $3
	in
	  (u, int_of_float $2, w, x, y, z)
      }
  | TokStacks TokNOMBRE sphere_body
      {
	let (u, v, _, x, y, z) = $3
	in
	  (u, v, int_of_float $2, x, y, z)
      }
  | TokColor color sphere_body
      {
	let (u, v, w, _, y, z) = $3
	in
	  (u, v, w, $2, y, z)
      }
  | TokDraw draw sphere_body
      {
	let (u, v, w, x, _, z) = $3
	in
	  (u, v, w, x, $2, z)
      }
  | TokContain TokDebCrochet objt_list sphere_body
      {
	let (u, v, w, x, y, _) = $4
	in
	  (u, v, w, x, y, Some (new point nan nan nan, ref 1., $3))
      }



empty_body:
    TokFinAccol
      {
	(new point nan nan nan), false, (new couleur nan nan nan nan), Close, None
      }
  | TokSize vect empty_body
      {
	let (_, w, x, y, z) = $3
	in
	  ($2, w, x, y, z)
      }
  | TokVisible TokBOOL empty_body
      {
	let (v, _, x, y, z) = $3
	in
	  (v, $2, x, y, z)
      }
  | TokColor color empty_body
      {
	let (v, w, _, y, z) = $3
	in
	  (v, w, $2, y, z)
      }
  | TokDraw draw empty_body
      {
	let (v, w, x, _, z) = $3
	in
	  (v, w, x, $2, z)
      }
  | TokContain TokDebCrochet objt_list empty_body
      {
	let (v, w, x, y, _) = $4
	in
	  (v, w, x, y, Some (new point nan nan nan, ref 1., $3))
      }



polyline_body:
    TokFinAccol
      {
	[], (new couleur nan nan nan nan), Close
      }
  | TokPointList TokDebCrochet polylinelist polyline_body
      {
	let (_, y, z) = $4
	in
	  ($3, y, z)
      }
  | TokColor color polyline_body
      {
	let (x, _, z) = $3
	in
	  (x, $2, z)
     }
  | TokDraw draw polyline_body
      {
	let (x, y, _) = $3
	in
	  (x, y, $2)
      }



translation_body:
  TokTranslation vect TokGeometry objt TokFinAccol
      {
	Transformation (Translation $2, $4)
      }
  | TokGeometry objt TokTranslation vect TokFinAccol
      {
	Transformation (Translation $4, $2)
      }



scale_body:
  TokScale vect TokGeometry objt TokFinAccol
      {
	Transformation (Scale $2, $4)
      }
  | TokGeometry objt TokScale vect TokFinAccol
      {
	Transformation (Scale $4, $2)
      }



rotation_body:
    TokFinAccol
      {
	AxeX, false, 0., false, Vide, false
      }
  | TokAxis axis rotation_body
      {
	let (_, _, w, x, y, z) = $3
	in
	  ($2, true, w, x, y, z)
      }
  | TokAngle TokNOMBRE rotation_body
      {
	let (u, v, _, _, y, z) = $3
	in
	  (u, v, $2, true, y, z)
      }
  | TokGeometry objt rotation_body
      {
	let (u, v, w, x, _, _) = $3
	in
	  (u, v, w, x, $2, true)
      }



group_body:
    TokFinAccol
      {
	[], new couleur nan nan nan 1.
      }
  | TokColor color group_body
      {
	let (x, _) = $3
	in
	  (x, $2)
      }
  | TokGridList TokDebCrochet objt_list group_body
      {
	let (_, y) = $4
	in
	  ($3, y)
      }



grid0_body:
    TokFinAccol
      {
	new point 0. 0. 0., Left, Left, Left, new couleur nan nan nan 1., []
      }
  | TokStartPoint vect grid0_body
      {
	let (_, v, w, x, y, z) = $3
	in
	  ($2, v, w, x, y, z)
      }
  | TokLineUp1 position grid0_body
      {
	let (u, _, w, x, y, z) = $3
	in
	  (u, $2, w, x, y, z)
      }
  | TokLineUp2 position grid0_body
      {
	let (u, v, _, x, y, z) = $3
	in
	  (u, v, $2, x, y, z)
      }
  | TokLineUp3 position grid0_body
      {
	let (u, v, w, _, y, z) = $3
	in
	  (u, v, w, $2, y, z)
      }
  | TokColor color grid0_body
      {
	let (u, v, w, x, _, z) = $3
	in
	  (u, v, w, x, $2, z)
      }
  | TokGridList TokDebCrochet grid_list grid0_body
      {
	let (u, v, w, x, y, _) = $4
	in
	  (u, v, w, x, y, $3)
      }



grid1_body:
    TokFinAccol
      {
	new point 0. 0. 0., AxeX, Left, Left, 0., new couleur nan nan nan 1., []
      }
  | TokStartPoint vect grid1_body
      {
	let (_, u, v, w, x, y, z) = $3
	in
	  ($2, u, v, w, x, y, z)
      }
  | TokAxis1 axis grid1_body
      {
	let (t, _, v, w, x, y, z) = $3
	in
	  (t, $2, v, w, x, y, z)
      }
  | TokLineUp2 position grid1_body
      {
	let (t, u, _, w, x, y, z) = $3
	in
	  (t, u, $2, w, x, y, z)
      }
  | TokLineUp3 position grid1_body
      {
	let (t, u, v, _, x, y, z) = $3
	in
	  (t, u, v, $2, x, y, z)
      }
  | TokSpace1 TokNOMBRE grid1_body
      {
	let (t, u, v, w, _, y, z) = $3
	in
	  (t, u, v, w, $2, y, z)
      }
  | TokColor color grid1_body
      {
	let (t, u, v, w, x, _, z) = $3
	in
	  (t, u, v, w, x, $2, z)
      }
  | TokGridList TokDebCrochet grid_list grid1_body
      {
	let (t, u, v, w, x, y, _) = $4
	in
	  (t, u, v, w, x, y, $3)
      }



grid2_body:
    TokFinAccol
      {
	new point 0. 0. 0., AxeNone, AxeNone, Middle, Middle, Left, 0., 0., (1., 1., 1.), new couleur nan nan nan 1., []
      }
  | TokStartPoint vect grid2_body
      {
	let (_,q , r, s, t, u, v, w, x, y, z) = $3
	in
	  ($2, q, r, s, t, u, v, w, x, y, z)
      }
  | TokAxis1 axis grid2_body
      {
	let (p, _, r, s, t, u, v, w, x, y, z) = $3
	in
	  (p, $2, r, s, t, u, v, w, x, y, z)
      }
  | TokAxis2 axis grid2_body
      {
	let (p, q, _, s, t, u, v, w, x, y, z) = $3
	in
	  (p, q, $2, s, t, u, v, w, x, y, z)
      }
  | TokLineUp1 position grid2_body
      {
	let (p, q, r, _, t, u, v, w, x, y, z) = $3
	in
	  (p, q, r, $2, t, u, v, w, x, y, z)
      }
  | TokLineUp2 position grid2_body
      {
	let (p, q, r, s, _, u, v, w, x, y, z) = $3
	in
	  (p, q, r, s, $2, u, v, w, x, y, z)
      }
  | TokLineUp3 position grid2_body
      {
	let (p, q, r, s, t, _, v, w, x, y, z) = $3
	in
	  (p, q, r, s, t, $2, v, w, x, y, z)
      }
  | TokSpace1 TokNOMBRE grid2_body
      {
	let (p, q, r, s, t, u, _, w, x, y, z) = $3
	in
	  (p, q, r, s, t, u, $2, w, x, y, z)
      }
  | TokSpace2 TokNOMBRE grid2_body
      {
	let (p, q, r, s, t, u, v, _, x, y, z) = $3
	in
	  (p, q, r, s, t, u, v, $2, x, y, z)
      }
  | TokRatio TokNOMBRE Tok2points TokNOMBRE Tok2points TokNOMBRE grid2_body
      {
	let (p, q, r, s, t, u, v, w, _, y, z) = $7
	in
	  (p, q, r, s, t, u, v, w, ($2, $4, $6), y, z)
      }
  | TokColor color grid2_body
      {
	let (p, q, r, s, t, u, v, w, x, _, z) = $3
	in
	  (p, q, r, s, t, u, v, w, x, $2, z)
      }
  | TokGridList TokDebCrochet grid_list grid2_body
      {
	let (p, q, r, s, t, u, v, w, x, y, _) = $4
	in
	  (p, q, r, s, t, u, v, w, x, y, $3)
      }



grid3_body:
    TokFinAccol
      {
	new point 0. 0. 0., AxeNone, AxeNone, Middle, Middle, Middle, 0., 0., 0., 1., 1., 1., new couleur nan nan nan 1., []
      }
  | TokStartPoint vect grid3_body
      {
	let (_, n, o, p, q, r, s, t, u, v, w, x, y, z) = $3
	in
	  ($2, n, o, p, q, r, s, t, u, v, w, x, y, z)
      }
  | TokAxis1 axis grid3_body
      {
	let (m, _, o, p, q, r, s, t, u, v, w, x, y, z) = $3
	in
	  (m, $2, o, p, q, r, s, t, u, v, w, x, y, z)
      }
  | TokAxis2 axis grid3_body
      {
	let (m, n, _, p, q, r, s, t, u, v, w, x, y, z) = $3
	in
	  (m, n, $2, p, q, r, s, t, u, v, w, x, y, z)
      }
  | TokLineUp1 position grid3_body
      {
	let (m, n, o, _, q, r, s, t, u, v, w, x, y, z) = $3
	in
	  (m, n, o, $2, q, r, s, t, u, v, w, x, y, z)
      }
  | TokLineUp2 position grid3_body
      {
	let (m, n, o, p, _, r, s, t, u, v, w, x, y, z) = $3
	in
	  (m, n, o, p, $2, r, s, t, u, v, w, x, y, z)
      }
  | TokLineUp3 position grid3_body
      {
	let (m, n, o, p, q, _, s, t, u, v, w, x, y, z) = $3
	in
	  (m, n, o, p, q, $2, s, t, u, v, w, x, y, z)
      }
  | TokSpace1 TokNOMBRE grid3_body
      {
	let (m, n, o, p, q, r, _, t, u, v, w, x, y, z) = $3
	in
	  (m, n, o, p, q, r, $2, t, u, v, w, x, y, z)
      }
  | TokSpace2 TokNOMBRE grid3_body
      {
	let (m, n, o, p, q, r, s, _, u, v, w, x, y, z) = $3
	in
	  (m, n, o, p, q, r, s, $2, u, v, w, x, y, z)
      }
  | TokSpace3 TokNOMBRE grid3_body
      {
	let (m, n, o, p, q, r, s, t, _, v, w, x, y, z) = $3
	in
	  (m, n, o, p, q, r, s, t, $2, v, w, x, y, z)
      }
  | TokRatio TokNOMBRE Tok2points TokNOMBRE Tok2points TokNOMBRE grid3_body
      {
	let (m, n, o, p, q, r, s, t, u, _, _, _, y, z) = $7
	in
	  (m, n, o, p, q, r, s, t, u, $2, $4, $6, y, z)
      }
  | TokColor color grid3_body
      {
	let (m, n, o, p, q, r, s, t, u, v, w, x, _, z) = $3
	in
	  (m, n, o, p, q, r, s, t, u, v, w, x, $2, z)
      }
  | TokGridList TokDebCrochet grid_list grid3_body
      {
	let (m, n, o, p, q, r, s, t, u, v, w, x, y, _) = $4
	in
	  (m, n, o, p, q, r, s, t, u, v, w, x, y, $3)
      }



hexa2_body:
    TokFinAccol
      {
	new point 0. 0. 0., AxeNone, AxeNone, Left, 0., (1., 1., 1.), new couleur nan nan nan 1., []
      }
  | TokStartPoint vect hexa2_body
      {
	let (_, t, u, v, w, x, y, z) = $3
	in
	  ($2, t, u, v, w, x, y, z)
      }
  | TokAxis1 axis hexa2_body
      {
	let (s, _, u, v, w, x, y, z) = $3
	in
	  (s, $2, u, v, w, x, y, z)
      }
  | TokAxis2 axis hexa2_body
      {
	let (s, t, _, v, w, x, y, z) = $3
	in
	  (s, t, $2, v, w, x, y, z)
      }
  | TokLineUp3 position hexa2_body
      {
	let (s, t, u, _, w, x, y, z) = $3
	in
	  (s, t, u, $2, w, x, y, z)
      }
  | TokSpace TokNOMBRE hexa2_body
      {
	let (s, t, u, v, _, x, y, z) = $3
	in
	  (s, t, u, v, $2, x, y, z)
      }
  | TokRatio TokNOMBRE Tok2points TokNOMBRE Tok2points TokNOMBRE hexa2_body
      {
	let (s, t, u, v, w, _, y, z) = $7
	in
	  (s, t, u, v, w, ($2, $4, $6), y, z)
      }
  | TokColor color hexa2_body
      {
	let (s, t, u, v, w, x, _, z) = $3
	in
	  (s, t, u, v, w, x, $2, z)
      }
  | TokGridList TokDebCrochet grid_list hexa2_body
      {
	let (s, t, u, v, w, x, y, _) = $4
	in
	  (s, t, u, v, w, x, y, $3)
      }



hexa3_body:
    TokFinAccol
      {
	new point 0. 0. 0., AxeNone, AxeNone, 0., 1., 1., 1., new couleur nan nan nan 1., []
      }
  | TokStartPoint vect hexa3_body
      {
	let (_, s, t, u, v, w, x, y, z) = $3
	in
	  ($2, s, t, u, v, w, x, y, z)
      }
  | TokAxis1 axis hexa3_body
      {
	let (r, _, t, u, v, w, x, y, z) = $3
	in
	  (r, $2, t, u, v, w, x, y, z)
      }
  | TokAxis2 axis hexa3_body
      {
	let (r, s, _, u, v, w, x, y, z) = $3
	in
	  (r, s, $2, u, v, w, x, y, z)
      }
  | TokSpace TokNOMBRE hexa3_body
      {
	let (r, s, t, _, v, w, x, y, z) = $3
	in
	  (r, s, t, $2, v, w, x, y, z)
      }
  | TokRatio TokNOMBRE Tok2points TokNOMBRE Tok2points TokNOMBRE hexa3_body
      {
	let (r, s, t, u, _, _, _, y, z) = $7
	in
	  (r, s, t, u, $2, $4, $6, y, z)
      }
  | TokColor color hexa3_body
      {
	let (r, s, t, u, v, w, x, _, z) = $3
	in
	  (r, s, t, u, v, w, x, $2, z)
      }
  | TokGridList TokDebCrochet grid_list hexa3_body
      {
	let (r, s, t, u, v, w, x, y, _) = $4
	in
	  (r, s, t, u, v, w, x, y, $3)
      }



view_body:
  /* rien */
      {
	AutoViewer, AutoCenter, AutoVertical
      }
  | TokViewer vect view_body
      {
	let (_, y, z) = $3
	in
	  (Viewer $2, y, z)
      }
  | TokCenter vect view_body
      {
	let (x, _, z) = $3
	in
	  (x, Center $2, z)
      }
  | TokVertical vect view_body
      {
	let (x, y, _) = $3
	in
	  (x, y, Vertical $2)
      }



mvt_body:
  /* rien */
      {
	((1., 1., 1.), (0., 0., 0.))
      }
  | TokDeltaX TokNOMBRE mvt_body
      {
	let ((vx, vy, vz), (_, y, z)) = $3
	in
	  ((vx, vy, vz), ($2, y, z))
      }
  | TokDeltaY TokNOMBRE mvt_body
      {
	let ((vx, vy, vz), (x, _, z)) = $3
	in
	  ((vx, vy, vz), (x, $2, z))
      }
  | TokDeltaZ TokNOMBRE mvt_body
      {
	let ((vx, vy, vz), (x, y, _)) = $3
	in
	  ((vx, vy, vz), (x, y, $2))
      }
  | TokSpeedX TokNOMBRE mvt_body
      {
	let ((_, vy, vz), (x, y, z)) = $3
	in
	  (($2, vy, vz), (x, y, z))
      }
  | TokSpeedY TokNOMBRE mvt_body
      {
	let ((vx, _, vz), (x, y, z)) = $3
	in
	  ((vx, $2, vz), (x, y, z))
      }
  | TokSpeedZ TokNOMBRE mvt_body
      {
	let ((vx, vy, _), (x, y, z)) = $3
	in
	  ((vx, vy, $2), (x, y, z))
      }




  /**********/
 /* Listes */
/**********/


scene_list:
    TokNOM TokVirgule scene_list
      { $1::$3 }
  | TokNOM
      { [$1] }



objt_list:
  objt TokVirgule objt_list
      { $1::$3 }
  | objt TokFinCrochet
      { $1::[] }



grid_list:
  objt TokVirgule grid_list
      { 
	($1, new point 0. 0. 0.)::$3
      }
  | objt TokFinCrochet
      {
	($1, new point 0. 0. 0.)::[]
      }



polylinelist:
  vect TokVirgule polylinelist
      {
	$1::$3
      }
  | vect TokFinCrochet
      {
	$1::[]
      }




  /*********************/
 /* types secondaires */
/*********************/


vect:
  TokInf TokNOMBRE TokVirgule TokNOMBRE TokVirgule TokNOMBRE TokSup
      {
	new point $2 $4 $6
      }



draw:
    TokBlend TokNOMBRE
      { Blend $2 }
  | TokClose
      { Close }
  | TokHalf
      { Mixed (Close, Shadow) }
  | TokMixed TokDebAccol mixed_body
      { let (d, u) = $3
	in
	  Mixed (d, u)
      }
  | TokNone
      { Shadow }
  | TokOpen
      { Open }
  | TokWire
      { Wire }



mixed_body:
    TokFinAccol
      {
	Shadow, Shadow
      }
  | TokDown draw mixed_body
      {
	let (_, u) = $3
	in
	  ($2, u)
      }
  | TokUp draw mixed_body
      {
	let (d, _) = $3
	in
	  (d, $2)
      }



axis:
    TokAxisX { AxeX }
  | TokAxisY { AxeY }
  | TokAxisZ { AxeZ }



position:
    TokLeft   { Left }
  | TokMiddle { Middle }
  | TokRight  { Right }



color:
  /* Couleur sans transparence */
    TokInf TokNOMBRE TokVirgule TokNOMBRE TokVirgule TokNOMBRE TokSup
      { new couleur $2 $4 $6 1. }
  /* Couleur avec transparence */
  | TokInf TokNOMBRE TokVirgule TokNOMBRE TokVirgule TokNOMBRE TokVirgule TokNOMBRE TokSup
      { new couleur $2 $4 $6 $8 }
